//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  TDBGrid ̃ZҏW̃{^\
//  ȗL (I{^EQƃ{^) ̃{^, PickList {^̕\
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2020N0304 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE5(UP2) Pro VCL-32
//  BDE 5.2 + Paradox 7.0
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Data.DB, Bde.DBTables,
  Vcl.Grids, Vcl.DBGrids, Vcl.StdCtrls, Vcl.ExtCtrls;

type
  TplDBGrid = class(TDBGrid)
  end;

  TForm1 = class(TForm)
    DataSource1: TDataSource;
    Panel1: TPanel;
    Query1: TQuery;
    Button1: TButton;
    DBGrid1: TDBGrid;
    Database1: TDatabase;
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure DBGrid1CellClick(Column: TColumn);
    procedure DBGrid1EditButtonClick(Sender: TObject);
  private
    { Private 錾 }
    plDBGrid1 : TplDBGrid;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
  plChgCompo;

{$R *.DFM}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
var
  LFieldNo : Integer;
begin
  // tH[쐬ɃR|[lg̓ւ
  plDBGrid1 := TplDBGrid(ChangeComponent(DBGrid1, TplDBGrid));

  // f[^x[X̐ݒ
  Query1.Close;
  Database1.Connected := False;
  Database1.DatabaseName := 'DBDEMOS';
  Database1.TransIsolation := tiDirtyRead;

  DataSource1.DataSet  := Query1;
  plDBGrid1.DataSource := DataSource1;
  Query1.DatabaseName  := Database1.DatabaseName;

  // XV\ɂ
  Query1.RequestLive := True;

  // f[^x[Xf[^擾ĕ\
  Query1.SQL.Clear;
  Query1.SQL.Add('select CustNo, Company, State, City from customer.db');
  Query1.Open;
  plDBGrid1.Columns[1].Width := 140;
  plDBGrid1.Columns[2].Width := 110;

  // gUNVJn
  Database1.StartTransaction;

  // ȗL{^ (I{^EQƃ{^) \̐ݒ
  LFieldNo := plDBGrid1.DataSource.DataSet.FieldByName('Company').FieldNo;
  plDBGrid1.Columns[LFieldNo - 1].ButtonStyle := cbsEllipsis;

  ActiveControl := plDBGrid1;
end;

//=============================================================================
//  tH[鎞̏
//=============================================================================
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  // eXgȂ̂ŃR~bg (XV) Ȃ
  Database1.Rollback;

  // f[^x[X
  Query1.Close;
  Database1.Close;
end;

//=============================================================================
//  {^NbNꂽ̃Cxg
//  _uNbNł̃Cxgs
//=============================================================================
procedure TForm1.DBGrid1EditButtonClick(Sender: TObject);
var
  LText : string;
begin
  inherited;

  if plDBGrid1.SelectedField.FieldName = 'Company' then begin
    plDBGrid1.DataSource.DataSet.Edit;
    plDBGrid1.SelectedField.AsString := 'V{}Vbv';
    plDBGrid1.DataSource.DataSet.Post;

    LText := plDBGrid1.SelectedField.Text;
    MessageBox(Handle, PChar(LText), '', MB_ICONINFORMATION);
    plDBGrid1.SetFocus;
  end;
end;

//=============================================================================
//  ZNbÑCxg
//  hbv_EXg (PickList) 쐬ăZbg
//=============================================================================
procedure TForm1.DBGrid1CellClick(Column: TColumn);
var
  LItemList : TStringList;
begin
  // hbv_EXg (PickList) \ƃXgڂ̐ݒ
  if Column.FieldName = 'State' then begin
    LItemList := TStringList.Create;
    try
      LItemList.Add('xR');
      LItemList.Add('茧');
      LItemList.Add('R`');
      LItemList.Add('쌧');
      LItemList.Add('R');

      plDBGrid1.Columns[Column.Field.FieldNo - 1].PickList := LItemList;
    finally
      FreeAndNil(LItemList);
    end;
  end;
end;

end.
