//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  TDBGird  PickList ̃hbv_EXg̃JX^}CY
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2020N0307 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE5(UP2) Pro VCL-32
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Data.DB, Bde.DBTables,
  Vcl.Grids, Vcl.DBGrids, Vcl.StdCtrls, Vcl.ExtCtrls;

type
  TplDBGridInplaceEditList  = class(TInplaceEditList)
  private
    procedure PickListDrawItemEvent(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure PickListClickEvent(Sender: TObject);
  protected
    procedure CreateWnd; override;
    procedure DropDown; override;
    procedure WMMouseWheel(var Message: TWMMouseWheel); message WM_MOUSEWHEEL;
    procedure DoGetPickListItems; override;
    procedure DoEditButtonClick; override;
    procedure CloseUp(Accept: Boolean); override;
  end;

  TplDBGrid = class(TDBGrid)
  public
    function CreateEditor: TInplaceEdit; override;
    function GetEditStyle(ACol: Integer; ARow: Integer): TEditStyle; override;
  end;

  TForm1 = class(TForm)
    Panel1: TPanel;
    DBGrid1: TDBGrid;
    Query1: TQuery;
    DataSource1: TDataSource;
    Database1: TDatabase;
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private 錾 }
     plDBGrid1 : TplDBGrid;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
  System.Types,
  plChgCompo;

{$R *.dfm}

//=============================================================================
//  tH[̏
//  eXgp̃f[^ TDBGrid ɕ\Ɗ֌W
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  // tH[쐬ɃR|[lg̓ւ
  plDBGrid1 := TplDBGrid(ChangeComponent(DBGrid1, TplDBGrid));

  // f[^x[X̐ݒ
  Query1.Close;
  Database1.Connected := False;
  Database1.DatabaseName := 'DBDEMOS';
  Database1.TransIsolation := tiDirtyRead;

  DataSource1.DataSet  := Query1;
  plDBGrid1.DataSource := DataSource1;
  Query1.DatabaseName  := Database1.DatabaseName;

  // XV\ɂ
  Query1.RequestLive := True;

  // f[^x[Xf[^擾ĕ\
  Query1.SQL.Clear;
  Query1.SQL.Add('select CustNo, Company, State, City from customer.db');
  Query1.Open;
  plDBGrid1.Columns[1].Width := 140;
  plDBGrid1.Columns[2].Width := 110;

  // gUNVJn
  Database1.StartTransaction;

  ActiveControl := plDBGrid1;
end;

//=============================================================================
//  tH[鎞̏
//=============================================================================
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  // eXgȂ̂ŃR~bg (XV) Ȃ
  Database1.Rollback;

  // f[^x[X
  Query1.Close;
  Database1.Close;
end;

{ TplDBGrid }

//=============================================================================
//  TDBGirdGetEditStyle \bh
//  {^̃X^C肷ۂɁCIɎs郁\bh
//  ǂ̍ () ɂǂ̃{^\邩ݒ肷
//=============================================================================
function TplDBGrid.GetEditStyle(ACol, ARow: Integer): TEditStyle;
begin
  if SelectedField.FieldName = 'Company' then begin
    Result := esEllipsis;
  end else
  if SelectedField.FieldName = 'State' then begin
    Result := esPickList;
  end else begin
    Result := inherited GetEditStyle(ACol, ARow);
  end;
end;

//=============================================================================
//  TDBGridCreateEditor \bh
//  ZҏWԂɂȂƎIɎs郁\bh
//  ŁCTInplaceEditList ̃CX^X𐶐
//  TInplaceEditList ̌pNX`ĂƂꂪIɎgp
//=============================================================================
function TplDBGrid.CreateEditor: TInplaceEdit;
begin
  inherited;
  Result := TplDBGridInplaceEditList.Create(Self);
end;

{ TplDBGridInplaceEditList }

//=============================================================================
//  TInplaceEditList pNX CreateWnd \bh
//  PickList(TListBox) ̃X^Cݒ
//  CvCXGfB^ TListBox ̃NX TPopupListbox
//  TStringGrid, TDBGrid, TValueListEditor 
//
//  ItemHeight ͍s̍ (sNZP)
//  DropDownRows 荀ڐȂꍇ͂̒l菭ȂlɂȂ
//
//  TInplaceEditList ɂ OnDrawItem, OnClick ̃Cxg⃁\bh͂Ȃ
//  ̓hbv_Eŕ\ TPopupListBox (TListBox) ̃Cxg
//  ̃CxgKvȂ`Ďgp\
//=============================================================================
procedure TplDBGridInplaceEditList.CreateWnd;
begin
  inherited;

  // TPopupListbox̌pTCustomListBox
  with TListBox(PickList) do begin
    ItemHeight  := 20;
    BevelKind   := bkFlat;
    BevelWidth  := 1;
    BevelInner  := bvNone;
    BevelOuter  := bvRaised;
    Style       := lbOwnerDrawFixed;
    IntegralHeight := True;
    DropDownRows   := 7;

    // JX^`pƃNbNCxg̒`DsvȂݒsv
    OnDrawItem := PickListDrawItemEvent;
    OnClick    := PickListClickEvent;
  end;
end;

//=============================================================================
//  TInplaceEditList NX DropDown \bh
//  TListBox \鎞ɔ郁\bh
//  CreateWnd ̎_ł͐ݒłȂeݒ
//
//  ʓIɃhbv_ẼXg [Alt] + [] ł\ł
//=============================================================================
procedure TplDBGridInplaceEditList.DropDown;
var
  LDBGrid   : TplDBGrid;
  LListBox  : TListBox;
  LCellRect : TRect;
  LItemIdx  : Integer;
begin
  inherited;

  LDBGrid  := TplDBGrid(Grid);
  LListBox := TListBox(PickList);

  // sƗԍZ̋`̈擾
  LCellRect := LDBGrid.CellRect(LDBGrid.Col, LDBGrid.Row);

  // TListBox ̔wiF
  LListBox.Color := $00FEF8E7;

  // TListBox ̕\
  LListBox.Width := LCellRect.Right - LCellRect.Left;

  // \JnɑIԂɂ鍀ڔԍ (0 x[X)
  // Z̕\ƓIԂɂ
  LItemIdx := LListBox.Items.IndexOf(LDBGrid.SelectedField.Text);
  if LItemIdx < 0 then LItemIdx := 0;
  LListBox.ItemIndex := LItemIdx;
end;

//=============================================================================
//  DoGetPickListItems \bh
//  Xg̍ڍ쐬KvɂȂɎs郁\bh
//  ŃXg̍ڂ̕쐬
//
//  TDBGrid ɂ͂̃\bhɑCxg͂Ȃ
//=============================================================================
procedure TplDBGridInplaceEditList.DoGetPickListItems;
var
  LDBGrid : TplDBGrid;
begin
  inherited;

  LDBGrid := TplDBGrid(Grid);

  if LDBGrid.SelectedField.FieldName = 'State' then begin
    with PickList.Items do begin
      BeginUpdate;
      Clear;
      Add('s');
      Add('ʌ');
      Add('_ސ쌧');
      Add('Qn');
      Add('Ȗ،');
      Add('錧');
      Add('t');
      Add('쌧');
      Add('R');
      Add('򕌌');
      Add('V');
      Add('');
      Add('R`');
      EndUpdate;
    end;
  end;
end;

//=============================================================================
//  CloseUp \bh
//  TListBox ɔ
//  Ńf[^x[X̃f[^XV
//  TInplaceEditList Oďꍇ̓f[^͎ōXVȂ
//  CvCXGfB^̒l͍XV
//
//  Accept = False ̎ [ESC] ⑼̃EBhEANeBuɂĕꍇ
//=============================================================================
procedure TplDBGridInplaceEditList.CloseUp(Accept: Boolean);
var
  LListBox : TListBox;
  LDBGrid  : TplDBGrid;
  LDataSet : TDataSet;
  LIndex   : Integer;
begin
  inherited;
  if not Accept then Exit;

  LListBox := TListBox(PickList);
  LDBGrid  := TplDBGrid(Grid);
  LDataSet := LDBGrid.DataSource.DataSet;

  LIndex := LListBox.ItemIndex;
  if LIndex < 0 then Exit;

  if LDBGrid.SelectedField.FieldName = 'State' then begin
    LDataSet.Edit;
    LDataSet.FieldByName('State').AsString := LListBox.Items[LIndex];
    LDataSet.Post;
  end;

  // ̓Lbg𕶎̍ŌɈړ
  LDBGrid.InplaceEditor.SelStart := Length(LDBGrid.SelectedField.Text);

  // ȉ̃R[hsꍇ͏̃R[h͕sv
  // hbv_EXgҏWKvȏꍇ͈ȉ͕sv
//  LDBGrid.EditorMode := False;
end;

//=============================================================================
//  ȗL̃{^NbNƎs郁\bh̏
//  Z̍̍Wl_CAO\
//
//  TInplaceEditList ̌pNX𐶐Ă̂
//   TDBGrid.OnEditButtonClick Cxg͔Ȃ̂łŏ
//=============================================================================
procedure TplDBGridInplaceEditList.DoEditButtonClick;
var
  LDBGrid   : TplDBGrid;
  LPos      : TPoint;
  LCellRect : TRect;
  LDialog   : TForm;
  LText     : string;
begin
  inherited;

  LDBGrid := TplDBGrid(Grid);

  if Assigned(LDBGrid.OnEditButtonClick) then begin
    LDBGrid.OnEditButtonClick(Self);
    Exit;
  end;

  if LDBGrid.SelectedField.FieldName = 'Company' then begin
    LText := LDBGrid.SelectedField.FieldName + ' ' + sLineBreak
           + 'ȗL{^NbN';

    LDialog := CreateMessageDialog(LText, mtInformation, [mbOK], mbOK);
    try
      LCellRect := LDBGrid.CellRect(LDBGrid.Col, LDBGrid.Row);
      LPos := LDBGrid.ClientToScreen(Point(LCellRect.Left, LCellRect.Bottom));

      LDialog.Left  := LPos.X;
      LDialog.Top   := LPos.Y + 5;
      LDialog.Width := 250;
      // _CAO\
      LDialog.ShowModal;
    finally
      FreeAndNil(LDialog);
    end;
  end;

  // _CAOҏWKvȏꍇ͈ȉ͕sv
//  LDBGrid.EditorMode := False;
end;

//-----------------------------------------------------------------------------
//  TListBox  OnClick Cxg
//  hbv_ẼXgIڂςɔ
//  NbN TListBox 
//-----------------------------------------------------------------------------
procedure TplDBGridInplaceEditList.PickListClickEvent(Sender: TObject);
begin
//
end;

//=============================================================================
//  TListBox ł̃}EXzC[̏
//  ̏Ȃƃ}EXzC[ŃXgĂ܂
//=============================================================================
procedure TplDBGridInplaceEditList.WMMouseWheel(var Message: TWMMouseWheel);
var
  LListBox : TListBox;
begin
  LListBox := TListBox(PickList);

  if LListBox.MouseInClient then begin
    if Message.WheelDelta > 0 then begin
      LListBox.Perform(WM_VSCROLL, MakeWParam(SB_LINEUP, 0), 0);
    end else begin
      LListBox.Perform(WM_VSCROLL, MakeWParam(SB_LINEDOWN, 0), 0);
    end;
  end else begin
    // TListBox ̈Oł̃}EXzC[ TListBox ꍇ
    // ȉ̃R[hs
//    inherited;
  end;
end;

//-----------------------------------------------------------------------------
//  TListBox  OnDrawItem Cxg
//  JX^`悪Kvȏꍇɗp
//  ̃CxggpƑSĂ̕`sKv
//  ftHg̕`gpꍇ͍폜
//
//  Iڂ̃eLXg`̐F (TFont.Color) ̃ftHg clWhite
//-----------------------------------------------------------------------------
procedure TplDBGridInplaceEditList.PickListDrawItemEvent(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  LListBox   : TCustomListBox;
  LRect      : TRect;
  LTempColor : TColor;
begin
  LListBox := TCustomListBox(Control);

  LTempColor := LListBox.Canvas.Font.Color;

  // JX^`̏ꍇC܂wihׂ
  if odSelected in State then begin
    // Is̔wiFƕ̐F
    LListBox.Canvas.Brush.Color := clHighlight;
    LListBox.Canvas.Font.Color  := clWhite;
  end;
  LRect := Rect;
  LListBox.Canvas.FillRect(LRect);

  LRect := Rect;
  InflateRect(LRect, -3, 0);
  DrawText(LListBox.Canvas.Handle,
           PChar(LListBox.Items[Index]),
           -1,
           LRect,
           DT_SINGLELINE or DT_LEFT or DT_VCENTER);

  LListBox.Canvas.Font.Color := LTempColor;

  //  tH[JX̘g`悵Ȃꍇ
  // ݂ TBrush.Color Řgd˕`
  if odFocused in State then begin
    LRect := Rect;
    DrawFocusRect(LListBox.Canvas.Handle, LRect);
  end;
end;

end.
